"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadScript = void 0;
var option_1 = require("./option");
var load_resource_1 = require("./load-resource");
var default_option_1 = require("./default-option");
/**
 * @public
 * @param src
 * @param id
 * @param timeoutSeconds
 * @param appendTo
 * @param executionStrategy
 */
var loadScript = function (_a) {
    var _b;
    var src = _a.src, id = _a.id, timeoutSeconds = _a.timeoutSeconds, appendTo = _a.appendTo, executionStrategy = _a.executionStrategy;
    return (0, load_resource_1.loadResource)({
        url: src,
        hostElementTagName: 'script',
        timeoutSeconds: (_b = timeoutSeconds !== null && timeoutSeconds !== void 0 ? timeoutSeconds : (0, default_option_1.getDefaultOption)().timeoutSeconds) !== null && _b !== void 0 ? _b : option_1.defaultTimeoutSeconds,
        id: id,
        appendTo: appendTo !== null && appendTo !== void 0 ? appendTo : (0, default_option_1.getDefaultOption)().appendTo,
        beforeElementCreateCallback: function (el) {
            if (el instanceof HTMLScriptElement) {
                switch (executionStrategy !== null && executionStrategy !== void 0 ? executionStrategy : (0, default_option_1.getDefaultOption)().executionStrategy) {
                    case 'async':
                        el.async = true;
                        el.defer = false;
                        break;
                    default:
                        el.defer = true;
                        el.async = false;
                }
            }
        },
    });
};
exports.loadScript = loadScript;
